
/* Implementaci de les operacions bsiques del tipus Laberint */

#include <stdlib.h>
#include <stdbool.h>
#include <assert.h>
#include "laberint.h"


Laberint CreaLaberint(int alt, int ample, bool ple) 
{
  int i,j;
  Laberint lab;

  lab.alt = alt;
  lab.ample = ample;

  lab.pos = malloc(alt*sizeof(bool *));
  assert(lab.pos!=NULL);
  for (i=0; i<alt; i=i+1) {
    lab.pos[i] = malloc(ample*sizeof(bool));
    assert(lab.pos[i]!=NULL);
    for (j=0; j<ample; j=j+1) {
      lab.pos[i][j] = ple;
    }
  }
   
  return lab;
}


void ModifPosLaberint(int x, int y, Laberint *const lab, bool ocupat)
{
  assert(x>=0 && y>=0 && x<(*lab).alt && y<(*lab).ample);

  (*lab).pos[x][y] = ocupat;
}


int AltLaberint(Laberint lab)
{
  return lab.alt;
}


int AmpleLaberint(Laberint lab)
{
  return lab.ample;
}


bool PosLabOcupada(int x, int y, Laberint lab)
{
  assert(x>=0 && y>=0 && x<lab.alt && y<lab.ample);

  return lab.pos[x][y];
}





void DestrueixLaberint(Laberint *const lab)
{
  int i;

  for (i=0; i<(*lab).alt; i=i+1) {
    free((*lab).pos[i]);
  }
  free((*lab).pos);

  (*lab).alt = 0;
  (*lab).ample = 0;
}
