
/* Tipus habitacle i les seves operacions bsiques */

#ifndef _HABITACLE_H
#define _HABITACLE_H

#include <stdbool.h>

typedef struct {
  int alt, ample;
  bool **pos;
} Laberint;

/* Crea un Laberint de les mides que se li indiquen, tot ocupat o tot lliure */
Laberint CreaLaberint(int alt, int ample, bool ple);

/* Modifica una posici d'un Laberint */
void ModifPosLaberint(int x, int y, Laberint *const hab, bool ocupat);

/* Consulten les mides d'un Laberint */
int AltLaberint(Laberint hab);
int AmpleLaberint(Laberint hab);

/* Consulta si una posici d'un Laberint est ocupada */
bool PosLabOcupada(int x, int y, Laberint hab);

/* Destrueix un Laberint */
void DestrueixLaberint(Laberint *const hab);


#endif
